# Contribute to Pulley
:tada::heart: First off, thanks for taking the time to contribute or considering to contribute! :heart::tada:

The following is a set of gidelines for contributing to the Pulley project. These are mostly guidelines, not rules. Use your best judgment, and feel free to propose changes to this document in a pull request. Also feel free to purpose changes to the new [issue templates](https://github.com/52inc/Pulley/tree/master/.github/ISSUE_TEMPLATE) or the new [pull request template](https://github.com/52inc/Pulley/blob/master/.github/PULL_REQUEST_TEMPLATE.md) in a pull request as well. 

## Code of Conduct

This project and everyone participating in it is governed by the [Pulley Code of Conduct](CODE_OF_CONDUCT.md). By participating, you are expected to uphold this code. Please report unacceptable behavior to [hello@52inc.com](mailto:hello@52inc.com).

## Your First Contribution

Working on your first Pull Request? You can learn how from this *free* series, [How to Contribute to an Open Source Project on GitHub](https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github).

## Reporting Bugs

This section guides you through submitting a bug report for Pulley.

Before creating bug reports, please check the open issues as you might find out that you don't need to create a new one. When you are creating a bug report, please include as many details as possible. Fill out [the required template](https://github.com/52inc/Pulley/tree/master/.github/ISSUE_TEMPLATE/pulley-bug-report.md), the information it asks for helps us resolve issues faster.

> **Note:** If you find a **Closed** issue that seems like it is the same thing that you're experiencing, open a new issue and include a link to the original issue in the body of your new one.

## Suggesting Features

This section guides you through submitting a feature suggestion for Pulley, including completely new features and minor improvements to existing functionality. Following these guidelines helps maintainers and the community understand your suggestion and find related suggestions.

Before creating feature suggestions, please check the open issues with the enhancement label as you might find out that you don't need to create one. When you are creating a feature suggestion, please include as many details as possible and fill in [the template](https://github.com/52inc/Pulley/blob/master/.github/ISSUE_TEMPLATE/pulley-feature-request.md).


## Submitting Code

This section guides you through submitting a pull request for Pulley. The goal being to imitate the behavior of the Apple Maps drawer, maintain backwards compatability, and maintain support for all iOS device size classes. 

Any code change should be submitted as a pull request. The description should explain what the code does, give steps to execute it, and breifly explan what steps were taken to test your code. Please follow the [pull request template](https://github.com/52inc/Pulley/blob/master/.github/PULL_REQUEST_TEMPLATE.md) as best you can and provide as much detail as possiable. 

## Code Review Process

We will do our best to review your request as soon as we can, but please keep in mind we are also full time developers. The bigger the pull request and the more parts of the application it can potentially effect, the longer it will take for us review and merge. Try to test as much as you can and think about how your pull request effects previous versions of iOS or the existing Pulley API before you submit it to us for review. It is also always helpful to have as much context as possiable for your pull request.

## Questions

If you have any questions, create a new issue using the [question issue template](https://github.com/52inc/Pulley/tree/master/.github/ISSUE_TEMPLATE/pulley-question.md). Please do a quick search first to see if someone else didn't ask the same question before you.
You can also reach us at [hello@52inc.com](mailto:hello@52inc.com).

## Credits

### Contributors

Thank you to all the people who have already contributed to Pulley! I hope you all continue to contribute because you all make the open source community a better place by contributing!

